routes/web.php
<?php

use App\Events\MensajePrivado;
use App\Events\MensajePublico;
use App\Events\NuevoRegistroPersona;
use App\Persona;
use App\User;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'InicioController@index')->name('inicio');

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home');

Route::middleware(['auth'])->group(function () {
    // persona
    Route::get('persona', 'PersonaController@index')->name('persona.index');
    Route::get('persona/reporte/listado/pdf', 'PersonaController@reporteListadoPdf')->name('persona.reportelistadopdf');
    Route::get('persona/reporte/listado/excel', 'PersonaController@reporteListadoExcel')->name('persona.reportelistadoexcel');
    // tipocurso
    Route::get('tipocurso', 'TipoCursoController@index')->name('tipocurso.index');
    Route::get('tipocurso/reporte/listado/pdf', 'TipoCursoController@reporteListadoPdf')->name('tipocurso.reportelistadopdf');
    Route::get('tipocurso/reporte/listado/excel', 'TipoCursoController@reporteListadoExcel')->name('tipocurso.reportelistadoexcel');
    // curso
    Route::get('curso', 'CursoController@index')->name('curso.index');
    Route::get('curso/reporte/listado/pdf', 'CursoController@reporteListadoPdf')->name('curso.reportelistadopdf');
    Route::get('curso/reporte/listado/excel', 'CursoController@reporteListadoExcel')->name('curso.reportelistadoexcel');
    // grupo
    Route::get('grupo', 'GrupoController@index')->name('grupo.index');
    Route::get('grupo/reporte/listado/pdf', 'GrupoController@reporteListadoPdf')->name('grupo.reportelistadopdf');
    Route::get('grupo/reporte/listado/excel', 'GrupoController@reporteListadoExcel')->name('grupo.reportelistadoexcel');
});

// sliders
Route::get('slider', 'SliderController@index')->name('slider.index');
// filtros
Route::get('tipocurso/{tipoCurso}', 'FiltroController@tipoCurso')->name('filtro.tipocurso.index');

Route::get('emitirevento', function () {
    $user = User::find(1);
    // crear tabla para eventos
    event(new NuevoRegistroPersona($user, "Jose Perez", 209));
    return "ok";
});

Route::get('generartoken', function(){
    $user = User::find(1);
    $token = $user->createToken('token-para-aplicacion-movil');
    return $token->plainTextToken;
});

app/Persona.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Persona extends Model
{
    use SoftDeletes;

    public function scopeFiltrarPorTexto($query, $texto)
    {
        return $query->where(function ($consulta) use ($texto) {
            if (!is_null($texto) && $texto !== '') {
                $consulta->where('apellido_paterno', 'LIKE', '%' . $texto . '%')
                    ->orWhere('apellido_materno', 'LIKE', '%' . $texto . '%')
                    ->orWhere('nombres', 'LIKE', '%' . $texto . '%');
            }
        })->orderBy('apellido_paterno', 'ASC')
            ->orderBy('apellido_materno', 'ASC')
            ->orderBy('nombres', 'ASC')
            ->paginate(20);
    }

    public function scopeBuscarPorTexto($query, $texto)
    {
        return $query->where(function ($consulta) use ($texto) {
            if (!is_null($texto) && $texto !== '') {
                $consulta->where('apellido_paterno', 'LIKE', '%' . $texto . '%')
                    ->orWhere('apellido_materno', 'LIKE', '%' . $texto . '%')
                    ->orWhere('nombres', 'LIKE', '%' . $texto . '%');
            }
        })->select('apellido_paterno', 'apellido_materno', 'nombres', 'email')
            ->orderBy('apellido_paterno', 'ASC')
            ->orderBy('apellido_materno', 'ASC')
            ->orderBy('nombres', 'ASC');
    }

    // relación de pertenencia con tabla distritos
    public function distrito()
    {
        return $this->belongsTo('App\Distrito');
    }

    // relación de uno a muchos con tabla matrículas
    public function matriculas()
    {
        return $this->hasMany('App\Matricula');
    }

    // relación de uno a uno con tabla red social
    public function redSocial()
    {
        return $this->hasOne('App\RedSocial');
    }

    public function imagen()
    {
        return $this->morphOne('App\Imagen', 'imagenable');
    }

    public function getNombreCompletoAttribute()
    {
        return $this->apellido_paterno . ' ' . $this->apellido_materno . ', ' . $this->nombres;
    }

    public function getNombreMayusculaAttribute()
    {
        return strtoupper($this->nombres);
    }
}

app/Http/Controllers/Api/PersonaController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Persona;
use Illuminate\Http\Request;

/**
* @OA\Info(title="API para información de persosas", version="1.0")
*
* @OA\Server(url="http://localhost/intermedio/public")
*/
class PersonaController extends Controller
{
    /**
    * @OA\Get(
    *     path="/api/personas",
    *     summary="Mostrar personas",
    *     @OA\RequestBody(
    *    required=true,
    *    description="Pass user credentials",
    *    @OA\JsonContent(
    *       required={"texto"},
    *       @OA\Property(property="texto", type="string", format="string", example="Jorge"),
    *    ),
    * ),
    *     @OA\Response(
    *         response=200,
    *         description="Mostrar todas las personas."
    *     ),
    *     @OA\Response(
    *         response="default",
    *         description="Ha ocurrido un error."
    *     )
    * )
    */
    public function index(Request $request)
    {
        return Persona::filtrarPorTexto($request->input("texto"));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/PersonaController.php
<?php

namespace App\Http\Controllers;

class PersonaController extends Controller
{
    protected $pathReportes;

    public function __construct()
    {
        $this->pathReportes = resource_path('reportes/persona/');
    }
    
    public function index()
    {
        return view('admin.persona.index');
    }

    public function reporteListadoPdf()
    {
        include $this->pathReportes. "listadoPdf.php";
    }

    public function reporteListadoExcel()
    {
        include $this->pathReportes. "listadoExcel.php";
    }
}

app/Http/Livewire/Curso/Admin.php
<?php

namespace App\Http\Livewire\Curso;

use App\Curso;
use App\TipoCurso;
use Gumlet\ImageResize;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\File;
use Livewire\Component;
use Livewire\WithFileUploads;
use Livewire\WithPagination;

class Admin extends Component
{
    use WithPagination;
    use WithFileUploads;
    protected $paginationTheme = 'bootstrap';
    public $nombre = '';
    public $nombre_corto = '';
    public $imagen = null;
    public $user_id = '';
    public $tipo_curso_id = '';
    public $tipo_cursos = [];
    public $textoBusqueda = '';
    public $curso_id = '';
    // cuando se va a editar un curso, se verifica si mostrarle la opción de eliminar 
    // su imagen actual. Si es null actualmente la imagen, se debe quitar esta opción
    public $imagen_url = '';
    public $tiene_imagen = false;
    public $quitar_imagen = false;

    public function mount()
    {
    }

    /**
     * Cuando se de clic sobre el botón de nuevo, se consultará en base
     * de datos la lista de tipos de curso
     *
     * @return void
     */
    public function crear()
    {
        $this->tipo_cursos = TipoCurso::select('id', 'nombre')->get()->toArray();
    }

    /**
     * Validar y registrar en base de datos
     *
     * @return void
     */
    public function registrar()
    {
        $this->validate([
            'nombre' => ['required', 'string', 'max:100'],
            'nombre_corto' => ['required', 'string', 'max:20'],
            'imagen' => ['nullable', 'image'],
            'tipo_curso_id' => ['required', 'exists:tipo_cursos,id']
        ], [],  [
            'tipo_curso_id' => 'tipo de curso'
        ]);
        $curso = new Curso();
        $curso->nombre = $this->nombre;
        $curso->nombre_corto = $this->nombre_corto;
        if (!is_null($this->imagen)) {
            $this->imagen->store('public/cursos');
            $curso->imagen = $this->imagen->hashName();
        }
        $curso->user_id = Auth::user()->id;
        $curso->tipo_curso_id = $this->tipo_curso_id;
        $curso->save();
        // inicio reducir imagen
        if (!is_null($curso->imagen_path)) {
            $pathImagen = $curso->imagen_path;
            $datosImagen = getimagesize($pathImagen);
            $ancho = $datosImagen[0];
            $alto = $datosImagen[1];
            $image = new ImageResize($pathImagen);
            if ($ancho >= 700 && $alto < 400) {
                $image->resizeToWidth(400);
            } elseif ($ancho < 700 && $alto >= 400) {
                $image->resizeToWidth(700);
            } elseif ($ancho < 700 && $alto < 400) {
                $image->resize(700, 400);
            }
            $image->crop(700, 400);
            $image->save($pathImagen);
            // fin reducir imagen
        }

        session()->flash('mensaje', 'Registrado correctamente');
        $this->reiniciarFormulario();
        $this->resetPage();
        $this->emit('cerrarModalNuevoCurso');
    }

    /**
     * Recibe el id de la base de datos y consulta para obtener los datos 
     * del registro
     *
     * @param int $id
     * @return void
     */
    public function editar($id)
    {
        $curso = Curso::find($id);
        $this->curso_id = $id;
        $this->nombre = $curso->nombre;
        $this->nombre_corto = $curso->nombre_corto;
        $this->user_id = $curso->user_id;
        $this->tipo_curso_id = $curso->tipo_curso_id;
        $this->tiene_imagen = (is_null($curso->imagen)) ? false : true;
        $this->imagen_url = $curso->imagen_url;
        $this->tipo_cursos = TipoCurso::select('id', 'nombre')->get()->toArray();
    }

    /**
     * Método para validar y actualizar en base de datos
     *
     * @return void
     */
    public function actualizar()
    {
        $this->validate([
            'nombre' => ['required', 'string', 'max:100'],
            'nombre_corto' => ['required', 'string', 'max:20'],
            'imagen' => ['nullable', 'image'],
            'tipo_curso_id' => ['required', 'exists:tipo_cursos,id']
        ], [],  [
            'tipo_curso_id' => 'tipo de curso'
        ]);
        $curso = Curso::find($this->curso_id);
        $curso->nombre = $this->nombre;
        $curso->nombre_corto = $this->nombre_corto;
        if ($this->quitar_imagen === true || !is_null($this->imagen)) {
            if (!is_null($curso->imagen_path)) {
                File::delete($curso->imagen_path);
                $curso->imagen = null;
            }
        }
        if (!is_null($this->imagen)) {
            $this->imagen->store('public/cursos');
            $curso->imagen = $this->imagen->hashName();
        }

        $curso->user_id = Auth::user()->id;
        $curso->tipo_curso_id = $this->tipo_curso_id;
        $curso->save();
        session()->flash('mensaje', 'Actualizado correctamente');
        $this->reiniciarFormulario();
        $this->resetPage();
        $this->emit('cerrarModalEditarCurso');
    }

    /**
     * Método que consulta en base de datos el registro que se va a 
     * eliminar
     *
     * @param int $id
     * @return void
     */
    public function eliminar($id)
    {
        $this->curso_id = $id;
        $curso = Curso::find($this->curso_id);
        $curso->nombre = $this->nombre;
    }

    /**
     * Método para eliminar de base de datos
     *
     * @return void
     */
    public function destruir()
    {
        Curso::destroy($this->curso_id);
        session()->flash('mensaje', 'Eliminado correctamente');
        $this->reiniciarFormulario();
        $this->resetPage();
        $this->emit('cerrarModalEliminarCurso');
    }

    /**
     * Método para retornar a los valores iniciales los atributos 
     * públicos
     *
     * @return void
     */
    public function reiniciarFormulario()
    {
        $this->reset(['nombre', 'nombre_corto', 'imagen', 'tipo_curso_id', 'tipo_cursos', 'curso_id', 'tiene_imagen', 'imagen_url', 'quitar_imagen']);
    }

    /**
     * Método encargado de refrescar la vista, cada vez que alguno de 
     * los atributos públicos que intervienen en este método, sufre un cambio
     */
    public function render()
    {
        $listado = Curso::where('nombre', 'LIKE', '%' . $this->textoBusqueda . '%')->paginate();
        return view('livewire.curso.admin', compact('listado'));
    }

    /**
     * Método para reiniciar la páginación cuando se hace una nueva búsqueda
     *
     * @return void
     */
    public function buscar()
    {
        $this->resetPage();
    }
}

app/Http/Livewire/Inicio/Cursos.php
<?php

namespace App\Http\Livewire\Inicio;

use App\Curso;
use Livewire\Component;
use Livewire\WithPagination;

class Cursos extends Component
{
    use WithPagination;

    protected $paginationTheme = 'bootstrap';

    public $tipoCurso = '';

    public function mount($tipoCurso = '')
    {
        $this->tipoCurso = $tipoCurso;
    }
    public function render()
    {
        $cursos = Curso::join('tipo_cursos', 'cursos.tipo_curso_id', '=', 'tipo_cursos.id')
            ->where(function ($query) {
                if ($this->tipoCurso !== '') {
                    $query->where('tipo_cursos.slug', $this->tipoCurso);
                }
            })->select('cursos.*')->orderBy('cursos.nombre', 'ASC')->paginate(30);
        return view('livewire.inicio.cursos', [
            'cursos' => $cursos
        ]);
    }
}

app/Http/Livewire/Persona/EditarFila.php
<?php

namespace App\Http\Livewire\Persona;

use App\Persona;
use Livewire\Component;

class EditarFila extends Component
{
    public $persona_id;
    public $email;
    public $editable = false;

    public function permitirEditar(){
        $this->editable = !$this->editable;
    }

    public function mount($persona){
        $this->persona_id = $persona->id;
        $this->email = $persona->email;
    }

    public function updatedEmail(){
        $persona = Persona::find($this->persona_id);
        $persona->email = $this->email;
        $persona->save();
    }

    public function render()
    {
        return view('livewire.persona.editar-fila');
    }
}

app/Http/Livewire/TipoCurso/Admin.php
<?php

namespace App\Http\Livewire\TipoCurso;

use App\TipoCurso;
use Livewire\Component;
use Livewire\WithPagination;

class Admin extends Component
{
    use WithPagination;

    protected $paginationTheme = 'bootstrap';

    public $tipoCurso;

    protected $rules = [
        'tipoCurso.nombre' => [
            'required',
            'string',
            'max:50'
        ]
    ];

    public function mount()
    {
        $this->tipoCurso = new TipoCurso();
        $this->tipoCurso->nombre = '';
    }

    public function registrar()
    {
        $this->validate([
            'tipoCurso.nombre' => ['required', 'string', 'max:50']
        ], [], [
            'tipoCurso.nombre' => 'nombre'
        ]);
        $this->tipoCurso->save();
        session()->flash('mensaje', 'Registrado correctamente');
        $this->reiniciarFormulario();
        $this->emit('cerrarModalNuevoTipoCurso');
    }

    public function editar($id)
    {
        $this->tipoCurso = TipoCurso::find($id);
    }

    public function actualizar()
    {
        $this->validate([
            'tipoCurso.nombre' => ['required', 'string', 'max:50']
        ], [], [
            'tipoCurso.nombre' => 'nombre'
        ]);
        $this->tipoCurso->save();
        session()->flash('mensaje', 'Actualizado correctamente');
        $this->reiniciarFormulario();
        $this->emit('cerrarModalEditarTipoCurso');
    }

    public function eliminar($id)
    {
        $this->tipoCurso = TipoCurso::find($id);
    }

    public function destruir()
    {
        TipoCurso::destroy($this->tipoCurso->id);
        session()->flash('mensaje', 'Eliminado correctamente');
        $this->reiniciarFormulario();
        $this->emit('cerrarModalEliminarTipoCurso');
    }

    public function reiniciarFormulario()
    {
        $this->tipoCurso = new TipoCurso();
        $this->tipoCurso->nombre = '';
    }

    public function render()
    {
        $listado = TipoCurso::paginate(30);
        return view('livewire.tipo-curso.admin', compact('listado'));
    }
}

resources/views/livewire/persona/admin.blade.php
<div class="card-body">
    {{-- Mensaje de confirmación --}}
    @if(session('mensaje'))
        <div class="alert alert-primary" role="alert">
            <strong>{{ session('mensaje') }}</strong>
        </div>
    @endif
    {{-- Formulario de búsqueda --}}
    <form class="form-inline" wire:submit.prevent='buscar'>
        <label class="form-label mb-2 mr-sm-2">Apellidos o nombres</label>
        <input type="text" class="form-control mb-2 mr-sm-2" wire:model.defer="textoBusqueda" />
        <button type="submit" class="btn btn-primary ml-2 mb-2">
            <i class="fas fa-search"></i> Buscar
        </button>
        <button type="button" data-toggle="modal" data-target="#modalNuevoPersona" class="btn btn-success ml-2 mb-2">
            <i class="fas fa-user"></i> Nuevo
        </button>
        {{-- Botón reporte EXCEL --}}
        <button class="btn btn-secondary ml-2 mb-2" wire:click='reporteExcel' >
            <i class="fas fa-file-excel"></i> Reporte
        </button>
        {{-- Botón reporte PDF --}}
        <button class="btn btn-secondary ml-2 mb-2" wire:click='reportePdf' >
            <i class="fas fa-file-pdf"></i> Reporte
        </button>
    </form>
    {{-- MODAL DE NUEVO --}}
    @include('livewire.persona.nuevo')
    {{-- MODAL DE EDITAR --}}
    @include('livewire.persona.editar')
    {{-- MODAL DE ELIMINAR --}}
    @include('livewire.persona.eliminar')
    {{-- MODAL DE EDITAR --}}
    <table class="table">
        <thead class="thead-dark">
            <tr>
                <th>Nombre completo</th>
                <th>Email</th>
                <th colspan="2">Operaciones</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($personas as $persona)
                <tr>
                    <td>{{ $persona->nombre_completo }}</td>
                    <td>{{ $persona->email }}</td>
                    <td>
                        <button data-toggle="modal" wire:click="editar({{ $persona->id }})" data-target="#modalEditarPersona" class="btn btn-warning">
                            <i class="fas fa-pencil-alt"></i> Editar
                        </button>
                    </td>
                    <td>
                        <button data-toggle="modal" wire:click="eliminar({{ $persona->id }})" data-target="#modalEliminarPersona" class="btn btn-danger">
                            <i class="fas fa-trash"></i> Eliminar
                        </button>
                    </td>
                </tr>
            @endforeach
        </tbody>
    </table>
    {{ $personas->links() }}
    @push('scriptsjs')
        <script type="text/javascript">
            // evento de javascript
            window.livewire.on('cerrarModalNuevoPersona', () => {
                $('#modalNuevoPersona').modal('hide');
            });
            // evento de javascript
            window.livewire.on('cerrarModalEditarPersona', () => {
                $('#modalEditarPersona').modal('hide');
            });
            // evento de javascript
            window.livewire.on('cerrarModalEliminarPersona', () => {
                $('#modalEliminarPersona').modal('hide');
            });
        </script>
    @endpush
</div>
@push('scripts')
    <script type="text/javascript">
        // evento de javascript
        window.livewire.on('cerrarModalNuevoPersona', () => {
            $('#modalNuevoPersona').modal('hide');
        });
        window.livewire.on('cerrarModalEditarPersona', () => {
            $('#modalEditarPersona').modal('hide');
        });
        window.livewire.on('cerrarModalEliminarPersona', () => {
            $('#modalEliminarPersona').modal('hide');
        });

    </script>
@endpush

resources/views/livewire/persona/crear.blade.php
<div wire:ignore.self class="modal fade" data-backdrop="static" id="modalNuevoPersona" tabindex="-1" role="dialog"
    aria-labelledby="modalNuevoPersonaLabel" aria-hidden="true">
    <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content">
            <div class="modal-header bg-dark text-white">
                <h5 class="modal-title" id="modalNuevoPersonaLabel">Registrar persona</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true close-btn">×</span>
                </button>
            </div>
            <div class="modal-body">
                <form>
                    <div class="form-group row">
                        <label class="col-md-2 col-form-label text-md-right" for="apellido_paterno">
                            Apellido paterno
                        </label>
                        <div class="col-md-4">
                            <input type="text" class="form-control" id="apellido_paterno" placeholder="Apellido paterno"
                                wire:model.defer="apellido_paterno">
                            @error('apellido_paterno')
                            <span class="text-danger error">{{ $message }}</span>
                            @enderror
                        </div>
                        <label class="col-md-2 col-form-label text-md-right" for="apellido_materno">
                            Apellido materno
                        </label>
                        <div class="col-md-4">
                            <input type="text" class="form-control" id="apellido_materno" placeholder="Apellido materno"
                                wire:model.defer="apellido_materno">
                            @error('apellido_materno') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                    </div>
                    <div class="form-group row">
                        <label class="col-md-2 col-form-label text-md-right" for="nombres">Nombres</label>
                        <div class="col-md-4">
                            <input type="text" class="form-control" id="nombres" placeholder="Nombres"
                                wire:model.defer="nombres">
                            @error('nombres') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                        <label class="col-md-2 col-form-label text-md-right" for="email">Correo eletrónico</label>
                        <div class="col-md-4">
                            <input type="email" class="form-control" id="email" placeholder="Correo electrónico"
                                wire:model.defer="email">
                            @error('email') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                    </div>
                    <div class="form-group row">
                        <label class="col-md-2 col-form-label text-md-right" for="celular">Celular</label>
                        <div class="col-md-4">
                            <input type="text" class="form-control" id="celular" placeholder="Celular"
                                wire:model.defer="celular">
                            @error('celular') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                    </div>
                    <div class="dropdown-divider"></div>
                    <div class="form-group row">
                        <label class="col-md-2 col-form-label text-md-right" for="departamento_id">Departamento</label>
                        <div class="col-md-4">
                            <select wire:model='departamento_id' class="custom-select" name="departamento_id"
                                id="departamento_id">
                                <option value='0' selected>Seleccionar</option>
                                @foreach ($departamentos as $departamento)
                                    <option value='{{ $departamento['id'] }}'>{{ $departamento['nombre'] }}</option>
                                @endforeach
                            </select>
                            @error('departamento_id') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                        <label class="col-md-2 col-form-label text-md-right" for="provincia_id">Provincia</label>
                        <div class="col-md-4">
                            <select wire:model='provincia_id' class="custom-select" name="provincia_id"
                                id="provincia_id">
                                <option value="0">Seleccionar</option>
                                @foreach ($provincias as $provincia)
                                    <option value="{{ $provincia['id'] }}">{{ $provincia['nombre'] }}</option>
                                @endforeach
                            </select>
                            @error('provincia_id') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                    </div>
                    <div class="form-group row">
                        <label class="col-md-2 col-form-label text-md-right" for="distrito_id">Distrito</label>
                        <div class="col-md-4">
                            <select wire:model.defer='distrito_id' class="custom-select" name="distrito_id"
                                id="distrito_id">
                                <option value="0">Seleccionar</option>
                                @foreach ($distritos as $distrito)
                                    <option value="{{ $distrito['id'] }}">{{ $distrito['nombre'] }}</option>
                                @endforeach
                            </select>
                            @error('distrito_id') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                        <label class="col-md-2 col-form-label text-md-right" for="direccion">Dirección</label>
                        <div class="col-md-4">
                            <input type="text" class="form-control" id="direccion" placeholder="Dirección"
                                wire:model.defer="direccion">
                            @error('direccion') <span class="text-danger error">{{ $message }}</span>@enderror
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer">
                <button type="button" wire:click='reiniciarFormulario()' class="btn btn-secondary close-btn"
                    data-dismiss="modal">
                    <i class="fa fa-window-close" aria-hidden="true"></i> Cerrar
                </button>
                <button type="button" wire:loading.attr="disabled" wire:click.prevent="nuevo"
                    class="btn btn-primary close-modal">
                    <i class="fas fa-check-circle"></i> Registrar
                </button>
            </div>
        </div>
    </div>
</div>

resources/views/livewire/persona/editar-fila.blade.php
<td>
    <input type="text" wire:model='email' class="form-control" @if(!$editable) disabled @endif />
    <button wire:click='permitirEditar'>Editar</button>
</td>

resources/views/livewire/persona/eliminar.blade.php
<div wire:ignore.self class="modal fade" data-backdrop="static" id="modalEliminarPersona" tabindex="-1" role="dialog"
    aria-labelledby="modalEliminarPersonaLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header bg-dark text-white">
                <h5 class="modal-title" id="modalEliminarPersonaLabel">Eliminar persona</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true close-btn">×</span>
                </button>
            </div>
            <div class="modal-body">
                <div class="alert alert-danger" role="alert">
                    <strong>¿Estás seguro de eliminar el registro:
                        {{ $apellido_paterno . ' ' . $apellido_materno }}?
                    </strong>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" wire:click='reiniciarFormulario()' class="btn btn-secondary close-btn"
                    data-dismiss="modal">
                    <i class="fa fa-window-close" aria-hidden="true"></i> Cerrar
                </button>
                <button type="button" wire:loading.attr="disabled" wire:click.prevent="destroy"
                    class="btn btn-danger close-modal">
                    <i class="fas fa-check-circle"></i> Eliminar
                </button>
            </div>
        </div>
    </div>
</div>